#include "matrice.hpp"


// A completer

bool Matrice::operator==(const Matrice& M) const{
  if(nl!=M.nl or nc!=M.nc){
    return false;
  }
  for(size_t i=0;i<nl;++i){
    for(size_t j=0;j<nc;++j){
      if(acces(i,j)!=M.acces(i,j)) return false;
    }
  }
  return true;
}


bool Matrice::operator!=(const Matrice& M) const{
  if(nl!=M.nl or nc!=M.nc){
    return true;
  }
  for(size_t i=0;i<nl;++i){
    for(size_t j=0;j<nc;++j){
      if(acces(i,j)!=M.acces(i,j)) return true;
    }
  }
  return false;
}

Matrice 
Matrice::operator+(const Matrice& M) const{
  assert(nl==M.nl and nc==M.nc);
  Matrice res(nl,nc);
  for(size_t i=0;i<nl;++i){
    for(size_t j=0;j<nc;++j){
      res.acces(i,j)=acces(i,j)+M.acces(i,j);
    }
  }
  return res;
}


Matrice 
Matrice::operator-(const Matrice& M) const{
  assert(nl==M.nl and nc==M.nc);
  Matrice res(nl,nc);
  for(size_t i=0;i<nl;++i){
    for(size_t j=0;j<nc;++j){
      res.acces(i,j)=acces(i,j)-M.acces(i,j);
    }
  }
  return res;
}



Matrice 
Matrice::operator*(const double& a) const{
  Matrice res(nl,nc);
  for(size_t i=0;i<nl;++i){
    for(size_t j=0;j<nc;++j){
      res.acces(i,j)=a*acces(i,j);
    }
  }
  return res;
}

Matrice 
Matrice::operator*(const Matrice& M) const{
  assert(nc==M.nl);
  Matrice res(lignes(),M.nc);
  for(size_t i=0;i<nl;++i){
    for(size_t j=0;j<M.nc;++j){
      double c=0;
      //Definir le coefficient res[i,j]
      for(size_t k=0;k<nc;++k){
	c+=acces(i,k)*M.acces(k,j);
      }
      res.acces(i,j)=c;
    }
  }
  return res;
}

void
Matrice::echange_lignes(size_t i,size_t j){
  assert(i<nl and j<nl);
  for(size_t k=0;k<nc;++k){
    double t=acces(i,k);
    acces(i,k)=acces(j,k);
    acces(j,k)=t;
  }
}

void
Matrice::multiplie_ligne(size_t i,double a){
  assert(i<nl and a!=0);
  for(size_t k=0;k<nc;++k){
    acces(i,k)*=a;
  }
}

void
Matrice::ajoute_multiple_ligne(size_t i,size_t j,double a){
  assert(i<nl and j<nl and i!=j);
  for(size_t k=0;k<nc;++k){
    acces(i,k)+=a*acces(j,k);
  }
}

Matrice
Matrice::Gauss() const{
  int l=0;
  Matrice A=*this;
  for(int c=0;c<nc;++c){
    //cout<<"c= "<<c<<" et l = "<<l<<endl;
    //cout<<"Recherche du premier coefficient dans la colonne "<<c<<endl;
    int p;
    for(p=l;p<nl;++p){
      if(A[p][c]!=0){
	//cout<<" -> pivot trouve à la ligne "<<p<<endl;
	break;
      }
    }
    if(p<nl){
      if(l!=p or true){
	//cout<<"L"<<l<<" <-> L"<<p<<endl;
	A.echange_lignes(l,p);
      }
      //cout<<A<<endl;
      //cout<<"L"<<l<<" <- 1/"<<A[l][c]<<"*L"<<l<<endl;
      A.multiplie_ligne(l,1/A[l][c]);
      //cout<<A<<endl;
      for(int i=0;i<nl;++i){
	if(i!=l and A[i][c]!=0){
	  //cout<<"L"<<i<<" <- L"<<i<<" - "<<A[i][c]<<"*L"<<l<<endl;
	  A.ajoute_multiple_ligne(i,l,-A[i][c]);
	  //cout<<A<<endl;
	}
      }
      ++l;
    }
    else{
      //cout<<"Pivot non trouve"<<endl;
    }
  }
  return(A);
}


/*
size_t
Matrice::rang() const{
}
*/


double
Matrice::determinant() const{
  assert(nc==nl);
  double mul=1;
  int l=0;
  Matrice A=*this;
  for(int c=0;c<nc;++c){
    int p;
    for(p=l;p<nl;++p){
      if(A[p][c]!=0){
	break;
      }
    }
    if(p<nl){
      if(l!=p or true){
	A.echange_lignes(l,p);
	mul*=-1;
      }
      double a=1/A[l][c];
      A.multiplie_ligne(l,a);
      mul*=a;
      for(int i=0;i<nl;++i){
	if(i!=l and A[i][c]!=0){
	  A.ajoute_multiple_ligne(i,l,-A[i][c]);
	}
      }
      ++l;
    }
    else{
      return 0;
    }
  }
  return 1/mul;
}



Matrice
Matrice::inverse() const{
  assert(nl==nc);
  int n=nl;
  Matrice M(n,2*n);
  for(int i=0;i<nl;++i){
    for(int j=0;j<nc;++j){
      M.acces(i,j)=acces(i,j);
    }
    M.acces(i,n+i)=1;
  }
  M=M.Gauss();
  assert(M.acces(n-1,n-1)==1);
  Matrice Inv(n,n);
  for(int i=0;i<nl;++i){
    for(int j=0;j<nc;++j){
      Inv.acces(i,j)=M.acces(i,j+n);
    }
  }
  return Inv;
}

